<template>
  <v-app class="medicalStaff">
    <v-main>
      <div class="medicalStaff__title">
        <h1>Список медперсонала</h1>
      </div>

      <!--Список медперсонала-->
      <v-data-table
          :headers="headers"
          :items="medicalStaff"
          class="medicalStaff__table"
      >
        <template v-slot:top>
          <v-toolbar flat>
            <v-spacer></v-spacer>
            <v-dialog v-model="dialog" max-width="500px">
              <template v-slot:activator="{ on, attrs }">
                <v-btn color="primary" dark class="mb-2" v-bind="attrs" v-on="on">Добавить медперсонал</v-btn>
              </template>

              <!--Добавление медперсонала-->
              <v-card>
                <v-card-title>
                  <span class="text-h5">{{ formTitle }}</span>
                </v-card-title>

                <v-card-text>
                  <v-container>
                    <v-row>
                      <v-col cols="12" sm="6" md="12">
                        <v-text-field v-model="editedItem.fullName" label="ФИО" :rules="fullNameRules"/>
                      </v-col>
                      <v-col cols="12" sm="6" md="12">
                        <v-text-field v-model="editedItem.role" label="Должность" :rules="fullNameRules"/>
                      </v-col>
                    </v-row>
                  </v-container>
                </v-card-text>

                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="#AFFFCF" @click="close">Закрыть</v-btn>
                  <v-btn color="#AFFFCF" @click="save">Сохранить</v-btn>
                </v-card-actions>
              </v-card>
            </v-dialog>

            <!--Удаление записи-->
            <v-dialog v-model="dialogDelete" max-width="510px">
              <v-card>
                <v-card-title class="text-h5">Вы уверены что хотите удалить запись?</v-card-title>
                <v-card-actions>
                  <v-spacer></v-spacer>
                  <v-btn color="#AFFFCF" @click="closeDelete">Закрыть</v-btn>
                  <v-btn color="#AFFFCF" @click="deleteItemConfirm">OK</v-btn>
                  <v-spacer></v-spacer>
                </v-card-actions>
              </v-card>
            </v-dialog>
          </v-toolbar>
        </template>

        <!--Иконки с действиями-->
        <template v-slot:item.actions="{ item }">
          <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil</v-icon>
          <v-icon small @click="deleteItem(item)">mdi-delete</v-icon>
        </template>
      </v-data-table>
    </v-main>
  </v-app>
</template>

<script>
import {
  mdiPencil,
  mdiDelete,
} from "@mdi/js"
import axios from "axios";

export default {
  name: "MedicalStaff",
  data() {
    return {
      icons: {
        mdiPencil,
        mdiDelete,
      },
      editedIndex: -1,
      dialog: false,
      dialogDelete: false,
      fullNameRules: [
        v => !!v || 'Заполните это поле',
        v => (v && v.length <= 255) || 'Поле должно содержать 255 символов',
      ],
      medicalStaff: [],

      editedItem: {
        fullName: '',
        role: ''
      },

      defaultItem: {
        fullName: '',
        role: ''
      },

      headers: [
        {
          text: 'ФИО',
          value: 'fullName',
          sortable: false
        },
        {
          text: 'Должность',
          value: 'role',
          sortable: false
        },
        {
          text: 'Действия',
          value: 'actions'
        }
      ]
    }
  },

  computed: {
    formTitle() {
      return this.editedIndex === -1 ? 'Новая запись' : 'Редактировать запись'
    },
  },

  watch: {
    dialog(val) {
      val || this.close()
    },
    dialogDelete(val) {
      val || this.closeDelete()
    },
  },

  mounted() {
    this.fetchMedicalStaff()
  },


  methods: {
    async fetchMedicalStaff() {
      axios
          .get(this.$root.globalVar + '/medical_staff')
          .then(response => {
            this.medicalStaff = response.data
          })
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: сервер отключен.')
          })
    },

    addMedicalStaff(item) {
      axios.post(this.$root.globalVar + '/medical_staff', {
        fullName: item.fullName,
        role: item.role
      })
          .then(response => this.medicalStaff.push(response.data))
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    updateMedicalStaff(item) {
      axios
          .put(this.$root.globalVar + '/medical_staff/' + item.id, {
            fullName: item.fullName,
            role: item.role
          })
          .then(Object.assign(this.medicalStaff[this.editedIndex], item))
          .catch(error => {
            console.log(error)
            alert('Ошибка! Подробности: введите данные в верном формате.')
          })
    },

    deleteMedicalStaff(item) {
      axios
          .delete(this.$root.globalVar + '/medical_staff/' + item.id)
          .catch(error => {
            console.log(error)
          })
      this.medicalStaff.splice(this.editedIndex, 1)
    },

    editItem(item) {
      this.editedIndex = this.medicalStaff.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialog = true
    },

    deleteItem(item) {
      this.editedIndex = this.medicalStaff.indexOf(item)
      this.editedItem = Object.assign({}, item)
      this.dialogDelete = true
    },

    deleteItemConfirm() {
      this.deleteMedicalStaff(this.editedItem)
      this.closeDelete()
    },

    close() {
      this.dialog = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    closeDelete() {
      this.dialogDelete = false
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem)
        this.editedIndex = -1
      })
    },

    save() {
      if (this.editedItem.fullName === '' || this.editedItem.role === '') {
        alert('Ошибка! Подробности: введите данные.')
        throw new Error("Ошибка! Подробности: введите ФИО.");
      }

      if (this.editedItem.fullName <= 0) {
        alert('Ошибка! Подробности: введите ФИО.')
        throw new Error("Ошибка! Подробности: введите ФИО.");
      }

      if (this.editedItem.role <= 0) {
        alert('Ошибка! Подробности: введите должность.')
        throw new Error("Ошибка! Подробности: введите ФИО.");
      }

      if (this.editedIndex > -1) {
        this.updateMedicalStaff(this.editedItem, this.editedIndex)
      } else {
        this.addMedicalStaff(this.editedItem)
      }
      this.close()
    },
  },
}
</script>

<style lang="scss" scoped>
.medicalStaff {
  &__title {
    text-align: center;
    margin-bottom: 20px;

    h1 {
      color: #45433b;
    }
  }

  &__table {
    width: 70%;
    margin: 0 auto;
  }
}
</style>